function LineSplitter (iterator,numberOfSegments){
    this.numberOfSegments = numberOfSegments
    this.iterator = iterator
    this.segments = new Array()
    this.getNextWords=function() {
    	var segmentStart = this.segments.pop()
    	var segmentEnd = this.segments.pop()
    	if (!segmentEnd) {
    		this.line = this.findLine()
			// It's bad style to stop the interval timer here
    		if (!this.line || this.line.length === 0) fireReader.intervalExecuter.stop()
    		this.segments = this.findSplits(this.line,this.numberOfSegments).reverse()
			segmentStart = this.segments.pop()
			segmentEnd = this.segments.pop()
    	}
    	var nextGroup = new Array()
    	for(var index=segmentStart; index<segmentEnd; index++) {
    		nextGroup.push(this.line[index])
    	}
    	this.segments.push(segmentEnd)
    	return nextGroup

    }
    this.findSplits = function(words,numberOfSegments){
		var segments = Array()
    	if (numberOfSegments > words.length) {
    		for(var index=0; index<=words.length; index++) {
    			segments.push(index)
    		}
    		return segments

    	}
    	var numberOfLetters = 0
    	words.each(function(word) {
    		numberOfLetters += word.data.length
    	})
		var numberOfLettersPerSegment = numberOfLetters / numberOfSegments -0.000001
		segments.push(0)
		var distanceToNextSplitPosition = numberOfLettersPerSegment
		for(var index=0; index<words.length; index++) {
			var wordLength = words[index].data.length
			if (wordLength>=distanceToNextSplitPosition){
				// Beginning of word is closer to split than end
				if (distanceToNextSplitPosition<wordLength-distanceToNextSplitPosition){
					index--
					distanceToNextSplitPosition += wordLength
				}
				distanceToNextSplitPosition += numberOfLettersPerSegment
				segments.push(index+1)
			}
			distanceToNextSplitPosition -= wordLength
		}
		segments.pop()
		segments.push(words.length)
        return segments

    }
    this.findLine = function()
    {var lastWord = ""
     var lastChar = ""
     lastWord.x = 0
     lastWord.y = 0
     var  line = new Array()
     var  lineLength = 0
     if (typeof(this.currentWord)=="undefined")
     {this.currentWord = this.iterator.next();
     }
     while (this.currentWord &&!
         (lastChar=="." || lastChar=="," || lastChar=="?" || lastChar=="!"
           || lastChar==";" || lastChar==":" || lastChar=="\""))
           {line.push(this.currentWord)
            lastWord = this.currentWord
            lastChar = lastWord.nodeValue.slice(-1)
            this.currentWord = this.iterator.next()
           }
     return line;
    }
}

function NodeListCreator(startNode) {
	//alert(startNode)
	    var treeWalker = document.createTreeWalker(startNode, NodeFilter.SHOW_TEXT, null, false);
        var  nodeList = new Array();
        do {
            nodeList.push(treeWalker.currentNode);
        } while (treeWalker.nextNode());
		//alert(nodeList)
        return nodeList;

}

function   WordIterator(nodes,parseNode) {
    this.parseNode = parseNode;
    this.nodes = nodes;
    this.nodeIndex = 0;
    this.wordIndex = -1;
    this.next = function(){
        if (this.nodeIndex >= this.nodes.length && this.wordIndex<0) {
            return null;
        }
        if(this.wordIndex < 0) {
            this.words = this.parseNode(this.nodes[this.nodeIndex]);
            this.wordIndex = this.words.length - 1;
            this.nodeIndex++;
            return this.next();
        }
        return this.words[this.wordIndex--];

    }

}

function PositionedWordIterator(wordIterator) {
    this.wordIterator = wordIterator
    this.next = function() {
        var nextWord = this.wordIterator.next();
        if (!nextWord) return nextWord
        var parentNode = nextWord.parentNode
        var span = document.createElementNS("http://www.w3.org/1999/xhtml", "span")
        if (nextWord.nextSibling)
        parentNode.insertBefore(span,nextWord.nextSibling)
        else
        parentNode.appendChild(span)
        var position = Position.cumulativeOffset(span)
        parentNode.removeChild(span)
        nextWord.x = position[0]
        nextWord.y = position[1]
        return nextWord
    }
}

var NodeHighlighter = Class.create();
NodeHighlighter.prototype={
	initialize:function(){},
    clearNodes : function (nodes) {
        var spans = new Array();
        nodes.each(function(node) {
            var span = node.parentNode
            span.parentNode.insertBefore(node,span)
            spans[span] = span
        })
        spans.each(function(span) {
            span.parentNode.removeChild(span)
        })
    },
    markNodes:function(nodes){
        var parentToSpan = new Array();
        nodes.each(function(node) {
            var parentNode = node.parentNode
            if (!parentToSpan[parentNode]) {
                parentToSpan[parentNode] = createSpan();
                parentNode.replaceChild(parentToSpan[parentNode],node)
            }
            parentToSpan[parentNode].appendChild(node);

        })
    },
}
function  createSpan() {
    var span = document.createElementNS("http://www.w3.org/1999/xhtml", "span");
    var id_stuff = "textmarked"
    var class_stuff = "textmarked_selection"

    span.setAttribute("id", id_stuff)
    span.setAttribute("class", class_stuff)
    span.setAttribute("name", class_stuff)
    span.style.backgroundColor = "#FFFF00"
    span.style.color = "#FF0000"
    return span;
}

var PeriodicalExecuter = Class.create();
PeriodicalExecuter.prototype = {
  initialize: function(callback, frequency) {
    this.callback = callback;
    this.frequency = frequency;
    this.currentlyExecuting = false;

    this.registerCallback();
  },

bind: function() {
  var __method = this.onTimerEvent, args = $A(arguments), object = args.shift();
  return function() {
    return __method.apply(object, args.concat($A(arguments)));
  }
},

  onTimerEvent: function() {
    if (!this.currentlyExecuting) {
      try {
        this.currentlyExecuting = true;
        this.callback();
      } finally {
        this.currentlyExecuting = false;
      }
    }
  },

  registerCallback: function() {
    this.intervalExecuter = setInterval(this.bind(this), this.frequency);//this.onTimerEvent.bind
  },

  updateFrequency:function(frequency) {
	clearInterval(this.intervalExecuter)
	this.frequency = frequency
	this.registerCallback()
  },

  stop:function() {
  	clearInterval(this.intervalExecuter)
  }
}

var SingleWordNodeParser = function(node){
    var words = new Array();
    if (!node || !node.data) return words;
    var positionOfNextWhitespace = 0;
    while ((positionOfNextWhitespace = node.data.lastIndexOf(" "))>=0){
        words.push(node.splitText(positionOfNextWhitespace));
    }
    words.push(node);
    return words;
}
function HighLighter(wordsReader) {
    this.wordsReader = wordsReader
    this.words = Array();
    this.oldWords = null;
    this.nodeHighlighter = new NodeHighlighter()
    this.highlightNewWords=function(){
        if (this.oldWords) this.nodeHighlighter.clearNodes(this.oldWords)
        this.nodeHighlighter.markNodes(this.words)
        this.oldWords = this.words;
        this.words = Array()
    }
    this.highlightNextGroup = function() {
        this.words = this.wordsReader.getNextWords();
        this.highlightNewWords();
    }
}



function nWordsReader(iterator,numberOfWords){
    this.numberOfWords = numberOfWords
    this.iterator = iterator
    this.currentWord = null
    this.lastWord = ""
    this.lastWord.x = 0
    this.lastWord.y = 0
    this.getNextWords=function() {
        var words = new Array()
        do {
            if (this.currentWord) {
            	words.push(this.currentWord)
        		this.lastWord = this.currentWord
            }
        	this.currentWord = this.iterator.next()
        }while (this.currentWord && words.length <= this.numberOfWords &&!
        (this.lastWord.y < this.currentWord.y && this.lastWord.x > this.currentWord.x))
        return words
    }

}

var fireReader = {
    init: function () {
        fireReader.currentTime = new Date()
		var body=$("span");
		if (body) body.setAttribute("onselect", "fireReader.scriptRead()");
        document.onkeyup = fireReader.updateInterval;
        //   var context = document.getElementById("contentAreaContextMenu");
        //    context.addEventListener("popupshowing",fireReader.popup,false);
        //    fireReader.word = document.getElementById("context-speedreadselection");
    },
    updateInterval:function (evt) {
    	if (!fireReader.intervalExecuter) return;
        evt = (evt) ? evt : ((event) ? event : null);
        if (evt) {
            var now = new Date()
            var timePassed = now.getTime() - fireReader.currentTime.getTime()
            fireReader.currentTime = now
            fireReader.intervalExecuter.updateFrequency(timePassed)
            fireReader.debug("New interval set: "+timePassed)
        }

    },

    popup: function ()
    {
        // gContextMenu.showItem("context-speedreadselection", gContextMenu.isTextSelected);
    },

    pluginRead:function(rootNode)
               {if (typeof(rootNode)=="undefined")
                   {var selection=new XPCNativeWrapper(window.content.getSelection(), 'getRangeAt()');
                    if (selection.rangeCount==0)
                       {alert('Please select a text-block first or use firereader in right-click menu!');
                        return;
                       }
                    var rootNode = selection.getRangeAt(0).commonAncestorContainer;
                    selection.removeAllRanges();
                   }
                fireReader.read(rootNode);
               },

    scriptRead:function()
               {selection=fireReader.getSelection();
                if (selection.rangeCount==0)
                   {alert('Please select a text-block first or use firereader in right-click menu!');
                    return;
                   }
                var rootNode = selection.getRangeAt(0).commonAncestorContainer;
                fireReader.read(rootNode);
               },

    read:function(rootNode)
         {//alert("Reading: "+selection);
          var iterator = new WordIterator(NodeListCreator(rootNode),SingleWordNodeParser);
          var positionedIterator = new PositionedWordIterator(iterator);
          if (typeof(fireReader.intervalExecuter)!="undefined" && typeof(fireReader.intervalExecuter.intervalExecuter)!="undefined")
          {clearInterval(fireReader.intervalExecuter.intervalExecuter);
           if (fireReader.highlighter.oldWords)
              {fireReader.highlighter.nodeHighlighter.clearNodes(fireReader.highlighter.oldWords);
              }
          }
          fireReader.highlighter=new HighLighter(new LineSplitter(positionedIterator,1));
          fireReader.intervalExecuter=
          new PeriodicalExecuter(function(){fireReader.highlighter.highlightNextGroup()},
                                 1000
                                );
         },

    debug : function (msg) {
        if (console) console.log(msg)
        try {
            Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).
            logStringMessage("FireReader: "+msg);
            dump("FireReader: "+msg);
    } catch (e) {}
    },

    getSelection : function ()
    {
        var txt = '';
        if (window.getSelection)
           {txt = window.getSelection();
           }
        else if (document.getSelection)
                {txt = document.getSelection();
                }
        else if (document.selection)
                {txt = document.selection.createRange().text;
                }
        return txt;
    }
};
//window.addEventListener("load", fireReader.init, false);
//window.addEventListener("onselect",fireReader.scriptRead, false);
